<script>

jQuery(document).ready(function($){

    function bindcommerce_js_random_text(length) {

        var result              = '';
        var characters          = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
        var characters_length   = characters.length;
        for ( var i = 0; i < length; i++ ) {
            result += characters.charAt(Math.floor(Math.random() * characters_length));
        }
        return result;

    }

    function bindcommerce_is_valid_json(text) {
        
        if (typeof text!=="string"){
            return false;
        }
        try{
            var json = JSON.parse(text);
            return (typeof json === 'object');
        }
        catch (error){
            return false;
        }

    }

    $("body").append(            
        "<div class=\"bindcommerce\">"
        + "     <div id=\"bc-update-modal\" class=\"bc-modal\">"
        + "         <div class=\"bc-modal-content\">"
        + "             <div class=\"bc-modal-header\">"
        + "                 <span class=\"bc-modal-close\">&times;</span>"
        + "             </div>"
        + "             <div class=\"bc-modal-body\">"
        + "             </div>"
        + "         </div>"
        + "     </div>"
        + "</div>"
    );    
    
    $('body').on('click', '.bindcommerce-reset-btn, .bindcommerce-cancel-reset', function(e){

        e.preventDefault();
        if (!$(this).hasClass("bc-disabled")) {
            $(this).closest(".bindcommerce-reset-container").find(".bindcommerce-reset-message").toggleClass("bc-hidden");
        }

    });

    $('body').on('click', '.bc-box-mapping-button', function(e){

        e.preventDefault();
        $(this).closest(".tab-boxes.bc-columns").find(".bc-box-mapping-button").each(function() {
            $(this).addClass("bc-hidden");
        });
        $(this).closest(".tab-boxes.bc-columns").find(".bc-column.bc-box").each(function() {
            $(this).addClass("bc-hidden");
        });
        $(this).closest(".bc-box").find(".bc-box-mapping-content").removeClass("bc-hidden");
        $(this).closest(".tab-box-container").addClass("bc-full-view");
        $(this).closest(".bc-box").addClass("bc-full-view");

    });    

    $('body').on('click', '.bc-box-mapping-content .bindcommerce-goback', function(e){

        e.preventDefault();
        $(this).closest(".tab-boxes.bc-columns").find(".bc-box-mapping-button").each(function() {
            $(this).removeClass("bc-hidden");
        });
        $(this).closest(".tab-boxes.bc-columns").find(".bc-column.bc-box").each(function() {
            $(this).removeClass("bc-hidden");
        });
        $(this).closest(".bc-box").find(".bc-box-mapping-content").addClass("bc-hidden");
        $(this).closest(".tab-box-container").removeClass("bc-full-view");
        $(this).closest(".bc-box").removeClass("bc-full-view");        

    });

    // Add row to table
    $('body').on('click', '.bc-mapping-fields-table .bindcommerce-add-field', function(e){

        e.preventDefault();

        var new_element = $(this).closest(".bindcommerce-input-row").clone();
        $('.bc-mapping-fields-table .bindcommerce-input-row-container').find($(this).closest(".bindcommerce-input-row")).after(new_element).html();

        $(this).find(".bindcommerce-duplicate-field").trigger("click");
        $(new_element).find(".bindcommerce-reset-field").trigger("click");

    });

    // Duplicate current row table
    $('body').on('click', '.bc-mapping-fields-table .bindcommerce-duplicate-field', function(e){

        e.preventDefault();

        var select_values = [];
        // Get select value and store in array
        $(this).closest(".bindcommerce-input-row").find(".bindcommerce-input").each(function() {

            if( $(this).is('select') ) {

                var select_class    = $(this).attr('class');
                select_class        = "." + select_class.replace(" ", ".");

                select_values.push({
                    class: select_class, 
                    value: $(this).find("option:selected").val()
                });

            }

        });

        var new_element = $(this).closest(".bindcommerce-input-row").clone();
        $(new_element).find("[name='bindcommerce_mapping_order_id']").val("0");
        $('.bc-mapping-fields-table .bindcommerce-input-row-container').find($(this).closest(".bindcommerce-input-row")).after(new_element).html();

        select_values.forEach(function(select) {

            if( $(new_element).find(select.class).is('select') ) {

                $(new_element).find(select.class).value = select.value;
                $(new_element).find(select.class).find("option[value='" + select.value + "']").prop("selected", true);

            };

        });


    });

    // Reset current row table
    
    $('body').on('click', '.bc-mapping-fields-table .bindcommerce-reset-field', function(e){

        e.preventDefault();

        $(this).closest(".bindcommerce-input-row").find(".bindcommerce-input").each(function() {

            $(this).val("");
            
            if ($(this).hasClass("bindcommerce-checkbox")) {
                $(this).prop("checked", false);
            }
            
        });

    });

    // Remove current row table
    $('body').on('click', '.bc-mapping-fields-table .bindcommerce-remove-field', function(e){

        e.preventDefault();

        var matched = $(".bc-mapping-fields-table .bindcommerce-input-row[data-bindcommerce-delete='0']");

        if (matched.length > 1) {
            // Delete row
            $(this).closest(".bindcommerce-input-row").attr("data-bindcommerce-delete", "1");
            $(this).closest(".bindcommerce-input-row").find("[name='bindcommerce_order_state_delete']").val(1);
            $(this).closest(".bindcommerce-input-row").addClass("bc-hidden");
        }

    });

    $('body').on('click', '#bindcommerce_export_product_button', function(e){

        e.preventDefault();
        var product = $(this);

        if( $(".bindcommerce_export_products_limit").length && !product.closest(".bc-box").find(".bindcommerce_export_products_limit option:selected").val() ) {
            return;
        }

        var product_id          = product.attr("data-product-id");
        var products_limit      = "";
        var products_order_by   = "";
        var products_start_by   = "";
        var products_end_by     = "";
        var products_mode       = "";
        var products_type       = "";

        if (product.closest(".bc-box").length) {

            products_limit      = product.closest(".bc-box").find(".bindcommerce_export_products_limit").val();
            products_order_by   = product.closest(".bc-box").find(".bindcommerce_export_products_order_by").val();
            products_start_by   = product.closest(".bc-box").find(".bindcommerce_export_products_start_by").val();
            products_end_by     = product.closest(".bc-box").find(".bindcommerce_export_products_end_by").val();
            products_mode       = product.closest(".bc-box").find(".bindcommerce_export_products_mode").val();
            products_type       = product.closest(".bc-box").find(".bindcommerce_export_products_type").val();

        }

        product.closest("#bindcommerce_product_data").find(".bindcommerce_export_product_button_field").addClass("dashicons-before dashicons-update");
        product.closest(".bc-box").find(".bc-dash-sync-icon").removeClass("dashicons-media-document");
        product.closest(".bc-box").find(".bc-dash-sync-icon").addClass("dashicons-update icon-rotating");

        $.ajax({ 

            method: 'POST',
            url: '<?php echo BindCommerce_Tools::get_plugin_url() . "includes/ajax/ajax-bindcommerce-export-product.php"; ?>',
            data: {
                "bindcommerce_ajax_token":                  '<?php echo BindCommerce_Setting::get_cron_token(); ?>',
                "bindcommerce_export_product":              product_id,
                "bindcommerce_export_products_limit":       products_limit,
                "bindcommerce_export_products_order_by":    products_order_by,
                "bindcommerce_export_products_start_by":    products_start_by,
                "bindcommerce_export_products_end_by":      products_end_by,
                "bindcommerce_export_products_mode":        products_mode,
                "bindcommerce_export_products_type":        products_type
            },

            success: function(output) {

                product.closest("#bindcommerce_product_data").find(".bindcommerce_export_product_button_field").removeClass("dashicons-before dashicons-update");
                product.closest(".bc-box").find(".bc-dash-sync-icon").removeClass("dashicons-update icon-rotating");                
                product.closest(".bc-box").find(".bc-dash-sync-icon").addClass("dashicons-media-document");

                var output_obj = JSON.parse(output);   
                var icon_message = "dashicons-yes-alt";     
                        
                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }    

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            },

            error: function (request, status, error) {

                product.closest("#bindcommerce_product_data").find(".bindcommerce_export_product_button_field").removeClass("dashicons-before dashicons-update");
                product.closest(".bc-box").find(".bc-dash-sync-icon").removeClass("dashicons-update icon-rotating");                
                product.closest(".bc-box").find(".bc-dash-sync-icon").addClass("dashicons-media-document");
                
                var output = request.responseText;
                var other_messages = "";
                var output_obj = "";
                if (bindcommerce_is_valid_json(output)) {
                    output_obj = JSON.parse(output);
                } else {                    
                    var bracket = '"\u007B'; // apex and curly left bracket
                    other_messages = output.substr(0, output.indexOf(bracket) - 2);
                    output = output.substring(output.indexOf(bracket));
                    output_obj = JSON.parse(JSON.parse(output));
                }

                var icon_message = "dashicons-warning";

                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    icon_message = "dashicons-yes-alt";
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }

                if (other_messages != "") {

                    default_message = "<?php echo __("La richiesta ha restituito i seguenti messaggi:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?>";
                    icon_message = "dashicons-warning";

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" 
                            + default_message 
                            + "<span class=\"bc-other-messages\">" 
                                + other_messages 
                            + "</span>"
                        + "</p>"
                    );

                }

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            }  

        }); //ajax

    }); //bindcommerce-export-product-button click

    $('body').on('click', '#bindcommerce_import_order_button, #bindcommerce_update_existing_order_button', function(e){

        e.preventDefault();

        var order = $(this);
        var import_new_order = true;
        var ajax_url = '<?php echo BindCommerce_Tools::get_plugin_url() . "includes/ajax/ajax-bindcommerce-import-order.php"; ?>';

        if ( $(this).is("#bindcommerce_update_existing_order_button") ) {
            import_new_order = false;
            ajax_url = '<?php echo BindCommerce_Tools::get_plugin_url() . "includes/ajax/ajax-bindcommerce-update-wc-order.php"; ?>';
        }

        if( !order.closest(".bc-box").find(".bindcommerce_import_orders_limit option:selected").val() ) {
            return;
        } 

        var order_id            = order.attr("data-order-id");
        var orders_limit        = order.closest(".bc-box").find(".bindcommerce_import_orders_limit").val();
        var orders_order_by     = order.closest(".bc-box").find(".bindcommerce_import_orders_order_by").val();
        order.closest(".bc-box").find(".bc-dash-sync-icon").removeClass("dashicons-cart");
        order.closest(".bc-box").find(".bc-dash-sync-icon").addClass("dashicons-update icon-rotating");

        $.ajax({ 

            method: 'POST',
            url: ajax_url,
            data: {
                "bindcommerce_ajax_token":              '<?php echo BindCommerce_Setting::get_cron_token(); ?>',
                "bindcommerce_import_order":            order_id,
                "bindcommerce_import_new_order":        import_new_order,
                "bindcommerce_import_orders_limit":     orders_limit,
                "bindcommerce_import_orders_order_by":  orders_order_by
            },

            success: function(output) {

                order.closest(".bc-box").find(".bc-dash-sync-icon").removeClass("dashicons-update icon-rotating");                
                order.closest(".bc-box").find(".bc-dash-sync-icon").addClass("dashicons-cart");

                var output_obj = JSON.parse(output);   
                var icon_message = "dashicons-yes-alt";     
                        
                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }    

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            },

            error: function (request, status, error) {

                order.closest(".bc-box").find(".bc-dash-sync-icon").removeClass("dashicons-update icon-rotating");                
                order.closest(".bc-box").find(".bc-dash-sync-icon").addClass("dashicons-cart");
                
                var output = request.responseText;
                var other_messages = "";
                var output_obj = "";
                if (bindcommerce_is_valid_json(output)) {
                    output_obj = JSON.parse(output);
                } else {                    
                    var bracket = '"\u007B'; // apex and curly left bracket
                    other_messages = output.substr(0, output.indexOf(bracket) - 2);
                    output = output.substring(output.indexOf(bracket));
                    output_obj = JSON.parse(JSON.parse(output));
                }

                var icon_message = "dashicons-warning";

                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    icon_message = "dashicons-yes-alt";
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }

                if (other_messages != "") {

                    default_message = "<?php echo __("La richiesta ha restituito i seguenti messaggi:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?>";
                    icon_message = "dashicons-warning";

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" 
                            + default_message 
                            + "<span class=\"bc-other-messages\">" 
                                + other_messages 
                            + "</span>"
                        + "</p>"
                    );

                }

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            }  

        }); //ajax

    }); //bindcommerce-import-order-button click, bindcommerce_update_existing_order_button click
    
    
    $('body').on('click', '.bindcommerce-delete-logs', function(e){

        e.preventDefault();

        var button_clicked = $(this);
        button_clicked.toggleClass("bc-button-updating");
        button_clicked.toggleClass("bc-disabled");

        $.ajax({ 

            method: 'POST',
            url: '<?php echo BindCommerce_Tools::get_plugin_url() . 'includes/ajax/ajax-bindcommerce-delete-logs.php'; ?>',
            data: {
                "bindcommerce_ajax_token":  '<?php echo BindCommerce_Setting::get_cron_token(); ?>',
                "bindcommerce_delete_logs": "1"
            },

            success: function(output) {

                var output_obj = JSON.parse(output);   
                var icon_message = "dashicons-yes-alt";     
                        
                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }    

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            },

            error: function (request, status, error) {
                
                var output = request.responseText;
                var other_messages = "";
                var output_obj = "";
                if (bindcommerce_is_valid_json(output)) {
                    output_obj = JSON.parse(output);
                } else {                    
                    var bracket = '"\u007B'; // apex and curly left bracket
                    other_messages = output.substr(0, output.indexOf(bracket) - 2);
                    output = output.substring(output.indexOf(bracket));
                    output_obj = JSON.parse(JSON.parse(output));
                }

                var icon_message = "dashicons-warning";

                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    icon_message = "dashicons-yes-alt";
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }

                if (other_messages != "") {

                    default_message = "<?php echo __("La richiesta ha restituito i seguenti messaggi:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?>";
                    icon_message = "dashicons-warning";

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" 
                            + default_message 
                            + "<span class=\"bc-other-messages\">" 
                                + other_messages 
                            + "</span>"
                        + "</p>"
                    );

                }

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            }  

        }).done(function() {        
            button_clicked.toggleClass("bc-button-updating");
            button_clicked.toggleClass("bc-disabled");    
        });

    }); //bindcommerce-delete-logs-button click


    $('body').on('click', '.bindcommerce-reset-settings-container .bindcommerce-confirm-reset', function(e){

        e.preventDefault();

        var button_clicked = $(this).closest(".bindcommerce-reset-settings-container").find(".bindcommerce-reset-btn");
        button_clicked.toggleClass("bc-button-updating");
        button_clicked.toggleClass("bc-disabled");

        $(this).closest(".bindcommerce-reset-container").find(".bindcommerce-reset-message").toggleClass("bc-hidden");  

        $.ajax({ 

            method: 'POST',
            url: '<?php echo BindCommerce_Tools::get_plugin_url() . "includes/ajax/ajax-bindcommerce-settings-reset.php"; ?>',
            data: {
                "bindcommerce_ajax_token":  '<?php echo BindCommerce_Setting::get_cron_token(); ?>',
                "bindcommerce_reset_options":   "1"
            },

            success: function(output) {

                var output_obj = JSON.parse(output);   
                var icon_message = "dashicons-yes-alt";     
                        
                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }    

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            },

            error: function (request, status, error) {
                
                var output = request.responseText;
                var other_messages = "";
                var output_obj = "";
                if (bindcommerce_is_valid_json(output)) {
                    output_obj = JSON.parse(output);
                } else {                    
                    var bracket = '"\u007B'; // apex and curly left bracket
                    other_messages = output.substr(0, output.indexOf(bracket) - 2);
                    output = output.substring(output.indexOf(bracket));
                    output_obj = JSON.parse(JSON.parse(output));
                }

                var icon_message = "dashicons-warning";

                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    icon_message = "dashicons-yes-alt";
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }

                if (other_messages != "") {

                    default_message = "<?php echo __("La richiesta ha restituito i seguenti messaggi:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?>";
                    icon_message = "dashicons-warning";

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" 
                            + default_message 
                            + "<span class=\"bc-other-messages\">" 
                                + other_messages 
                            + "</span>"
                        + "</p>"
                    );

                }

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            }  

        }).done(function() {        
            button_clicked.toggleClass("bc-button-updating");
            button_clicked.toggleClass("bc-disabled");   
        });

    }); //bindcommerce-confirm-reset click



    $('body').on('click', '.bindcommerce-save', function(e){

        e.preventDefault();
        
        var button_clicked = $(this);
        button_clicked.toggleClass("bc-button-updating");
        button_clicked.toggleClass("bc-disabled");
        
        var obj = {};
        var inputs_container = "";

		if ($(this).closest(".season_content").find(".tab-boxes").length) { 

            inputs_container = $(this).closest(".tab-boxes").find(".bc-mapping-fields-container");

        } else {

            inputs_container = $(this).closest(".season_content");

        }

        inputs_container.children(".row").find(".bindcommerce-input").each(function() {	

            var key = $(this).attr("name");
            var value = "";

            if( $(this).is('select') ) {

                value = $(this).find("option:selected").val();   

            } else if ( $(this).hasClass("wp-bindcommerce-editor")) {

                var id_element = $(this).attr("id");				
                var html_text = tinymce.get(id_element).getContent();
                value = html_text;

            } else if ( $(this).is('textarea') ) {

                value = $(this).val();

            } else if ( $(this).hasClass('bindcommerce-checkbox') ) {

                if ($(this).is(':checked')) {

                    value = 1;

                } else {

                    value = 0;         

                }

            } else {

                value = $(this).val();

            }

            if (value == undefined) { 

                value = ""; 

            }

            obj[key] = value;
        });

        $.ajax({ 

            method: 'POST',
            url: '<?php echo BindCommerce_Tools::get_plugin_url() . 'includes/ajax/ajax-bindcommerce-settings-update.php'; ?>',
            data: {
                "bindcommerce_ajax_token":      '<?php echo BindCommerce_Setting::get_cron_token(); ?>',
                "bindcommerce_update_options":  obj
            },

            success: function(output) {

                var output_obj = JSON.parse(output);   
                var icon_message = "dashicons-yes-alt";     
                        
                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }    

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            },

            error: function (request, status, error) {
                
                var output = request.responseText;
                var other_messages = "";
                var output_obj = "";
                if (bindcommerce_is_valid_json(output)) {
                    output_obj = JSON.parse(output);
                } else {                    
                    var bracket = '"\u007B'; // apex and curly left bracket
                    other_messages = output.substr(0, output.indexOf(bracket) - 2);
                    output = output.substring(output.indexOf(bracket));
                    output_obj = JSON.parse(JSON.parse(output));
                }

                var icon_message = "dashicons-warning";

                if (output_obj.status == "success") {
 
                    $(".bc-modal-header").removeClass("bc-error-modal");
                    icon_message = "dashicons-yes-alt";
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }

                if (other_messages != "") {

                    default_message = "<?php echo __("La richiesta ha restituito i seguenti messaggi:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?>";
                    icon_message = "dashicons-warning";

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" 
                            + default_message 
                            + "<span class=\"bc-other-messages\">" 
                                + other_messages 
                            + "</span>"
                        + "</p>"
                    );

                }

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            }  

        }).done(function() {
            button_clicked.toggleClass("bc-button-updating");
            button_clicked.toggleClass("bc-disabled");         
        }); //ajax

    }); //bindcommerce-save click

    
    $('body').on('click', '.bindcommerce-save-mapping', function(e){

        e.preventDefault();

        var button_clicked = $(this);
        button_clicked.toggleClass("bc-button-updating");
        button_clicked.toggleClass("bc-disabled");

        var order_states = [];

        $(this).closest(".bc-box-mapping-content").find(".bc-mapping-fields-table").find(".bindcommerce-input-row").each(function(){	

            var obj = {};

            $(this).find(".bindcommerce-input").each(function(){

                var key = $(this).attr("name");
                var value = "";

                if( $(this).is('select') ) {

                    value = $(this).find("option:selected").val();   

                } else if ( $(this).is('textarea') ) {

                    value = $(this).val();

                } else if ( $(this).hasClass('bindcommerce-checkbox') ) {

                    if ($(this).is(':checked')) {

                        value = 1;

                    } else {

                        value = 0;         

                    }

                } else {

                    value = $(this).val();

                }

                if (value == undefined) { 

                    value = ""; 

                }

                obj[key] = value;

            });
            
            order_states.push(obj);

        });
        
        $.ajax({ 

            method: 'POST',
            url: '<?php echo BindCommerce_Tools::get_plugin_url() . "includes/ajax/ajax-bindcommerce-mapping-import-order-states.php"; ?>',
            data: {
                "bindcommerce_ajax_token":              '<?php echo BindCommerce_Setting::get_cron_token(); ?>',
                "bindcommerce_mapping_order_states":    order_states
            },

            success: function(output) {

                var output_obj = JSON.parse(output);   
                var icon_message = "dashicons-yes-alt";     
                        
                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }    

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            },

            error: function (request, status, error) {
                
                var output = request.responseText;
                var other_messages = "";
                var output_obj = "";
                if (bindcommerce_is_valid_json(output)) {
                    output_obj = JSON.parse(output);
                } else {                    
                    var bracket = '"\u007B'; // apex and curly left bracket
                    other_messages = output.substr(0, output.indexOf(bracket) - 2);
                    output = output.substring(output.indexOf(bracket));
                    output_obj = JSON.parse(JSON.parse(output));
                }

                var icon_message = "dashicons-warning";

                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    icon_message = "dashicons-yes-alt";
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }

                if (other_messages != "") {

                    default_message = "<?php echo __("La richiesta ha restituito i seguenti messaggi:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?>";
                    icon_message = "dashicons-warning";

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" 
                            + default_message 
                            + "<span class=\"bc-other-messages\">" 
                                + other_messages 
                            + "</span>"
                        + "</p>"
                    );

                }

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            }  

        }).done(function() {
            button_clicked.toggleClass("bc-button-updating");
            button_clicked.toggleClass("bc-disabled");
        }); // ajax

    }); //bindcommerce-save-mapping click

    $('body').on('click', '.bindcommerce-read-mode-btn', function(e){

        $(this).closest(".lbl-tip").find(".bindcommerce-read-mode-text").toggleClass("bc-hidden");

    }); //bindcommerce-read-mode-btn click

    $('body').on('click', '.bindcommerce-refresh-token', function(e){

        e.preventDefault();

        var new_token = bindcommerce_js_random_text(32);

        $(this).closest(".season_content").children(".row").find(".bindcommerce-input[name^='bindcommerce_cron']").each(function(){	
        
            var input_value = $(this).val();

            if (input_value != "") {
                
                if (input_value.indexOf("token=") !== -1) {

                    $(this).val( input_value.substring(0, input_value.indexOf("token=")) + "token=" + new_token);                

                } else {

                    $(this).val(new_token);           

                }

            }

        });


    }); //bindcommerce-refresh-token click

    var bc_update_modal = document.getElementById("bc-update-modal");
    var bc_update_span  = document.getElementsByClassName("bc-modal-close")[0];

    // When the user clicks on <span> (x), close the modal
    bc_update_span.onclick = function() {

        bc_update_modal.style.display = "none";

        if (JSON.parse(bc_update_modal.getAttribute("refresh")) == true) {

            <?php 

            $current_url = trim( $_SERVER['REQUEST_URI'], "/" ) ;
            if (strpos($current_url, 'page-bindcommerce-settings') !== false) {

                echo "window.location.href = window.location.href;";

            }

            ?>

        }

    }

    window.onclick = function(event) {
        
        if (event.target == bc_update_modal) {

            bc_update_modal.style.display = "none";
            
            if (JSON.parse(bc_update_modal.getAttribute("refresh")) == true) {

                <?php 

                $current_url = trim( $_SERVER['REQUEST_URI'], "/" ) ;
                if (strpos($current_url, 'page-bindcommerce-settings') !== false) {

                    echo "window.location.href = window.location.href;";

                }

                ?>  

            }

        }

    }

    <?php


    if ( isset($_GET["post"]) && !empty($_GET["post"]) ) {  

        $wc_order_id = BindCommerce_DB::get_result("

            SELECT post_id 
            FROM " . DB_NAME . "." . BINDCOMMERCE_DB_WP_PREFIX . "postmeta" . " " . "
            WHERE post_id = '" . sanitize_text_field($_GET["post"]) . "';

        ");


        if ( !empty($wc_order_id) ) {

            // Add Missing Products to WooCommerce Order Items
            $missing_products = BindCommerce_DB::get_result("
        
                SELECT meta_value 
                FROM " . DB_NAME . "." . BINDCOMMERCE_DB_WP_PREFIX . "postmeta" . " " . "
                WHERE post_id = '" . $wc_order_id . "' 
                AND meta_key = '". BINDCOMMERCE_ORDER_META_MISSING_PRODUCTS . "';
                
            ");

            if ( !empty($missing_products) ) { 
                ?>

                    var obj = <?php echo $missing_products; ?>; 
                    for (var key in obj.products) {

                        var product_code                = obj.products[key].product.Code;
                        var product_description         = obj.products[key].product.Description;
                        var product_picture             = obj.products[key].product.Picture;
                        var product_quantity            = obj.products[key].product.Qty;
                        var product_vat_rate            = obj.products[key].product.VatRate;
                        var product_total_vat_excluded  = obj.products[key].product.TotalVatExcluded;
                        var product_total               = obj.products[key].product.Total;
                        var product_total_discounted    = obj.products[key].product.TotalDiscounted;
                        var product_currency            = obj.products[key].product.Currency;

                        $("table.woocommerce_order_items #order_line_items").append(

                            '<tr class="item bindcommerce-order-item">'

                            + '   <td class="thumb">'
                            + '       <div class="wc-order-item-thumbnail"><img width="150" height="150" src="' + product_picture + '" class="attachment-thumbnail size-thumbnail" alt="" loading="lazy" title="">'
                            + '       </div>'	
                            + '   </td>'

                            + '   <td class="name" data-sort-value="' + product_description + '">' + product_description + ' <span style="color:#d80000;"><?php echo __("(Prodotto non presente su WooCommerce)", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?></span>'
                            + '        <div class="wc-order-item-sku">'
                            + '            <strong><?php echo __("COD:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?></strong> ' + product_code
                            + '        </div>'
                            + '   </td>'

                            + '    <td class="item_cost" width="1%" data-sort-value="' + product_total + '">'
                            + '        <div class="view">'
                            + '            <span class="woocommerce-Price-amount amount"><bdi>' + product_total + '<span class="woocommerce-Price-currencySymbol">' + product_currency + '</span></bdi></span>		</div>'
                            + '    </td>'

                            + '    <td class="quantity" width="1%">'
                            + '        <div class="view">'
                            + '            <small class="times">×</small> ' + product_quantity + '		</div>'
                            + '        <div class="edit" style="display: none;">'
                            + '            <input type="number" step="1" min="0" autocomplete="off" placeholder="0" value="1" data-qty="1" size="4" class="quantity">'
                            + '        </div>'
                            + '        <div class="refund" style="display: none;">'
                            + '            <input type="number" step="1" min="0" max="1" autocomplete="off" placeholder="0" size="4" class="refund_order_item_qty">'
                            + '        </div>'
                            + '    </td>'

                            + '    <td class="line_cost" width="1%" data-sort-value="' + product_total + '">'
                            + '        <div class="view">'
                            + '            <span class="woocommerce-Price-amount amount"><bdi>' + product_total + '<span class="woocommerce-Price-currencySymbol">' + product_currency + '</span></bdi></span>		</div>'
                            + '        <div class="edit" style="display: none;">'
                            + '            <div class="split-input">'
                            + '                <div class="input">'
                            + '                    <label>Prima dello sconto</label>'
                            + '                    <input type="text" placeholder="0" value="' + product_total + '" class="line_subtotal wc_input_price" data-subtotal="' + product_total + '">'
                            + '                </div>'
                            + '                <div class="input">'
                            + '                    <label>Totale</label>'
                            + '                    <input type="text" placeholder="0" value="' + product_total_discounted + '" class="line_total wc_input_price" data-tip="<?php echo __("Dopo gli sconti pre-tassazione", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?>" data-total="' + product_total_discounted + '">'
                            + '                </div>'
                            + '            </div>'
                            + '        </div>'
                            + '        <div class="refund" style="display: none;">'
                            + '            <input type="text" placeholder="0" class="refund_line_total wc_input_price">'
                            + '        </div>'
                            + '    </td>'

                            + '    <td class="wc-order-edit-line-item" width="1%">'
                            + '        <div class="wc-order-edit-line-item-actions">'
                            + '        </div>'
                            + '    </td>'

                            + '</tr>'                        
                        
                        );

                    }
            
                <?php
            }

        }

    }
    


    // WooCommerce Single Order Preview 

    ?>

    
    $('body').on('click', 'a.order-preview', function(e){

        var bindcommerce_missing_products = setInterval(function() {

			if ($(".bindcommerce-missing-products").length) {

                missing_products = $(".bindcommerce-missing-products").attr("data-products");

                if (!missing_products) {
                    return;
                }

                var obj = JSON.parse( missing_products );

                for (var key in obj.products) {

                    var product_code                = obj.products[key].product.Code;
                    var product_description         = obj.products[key].product.Description;
                    var product_picture             = obj.products[key].product.Picture;
                    var product_quantity            = obj.products[key].product.Qty;
                    var product_vat_rate            = obj.products[key].product.VatRate;
                    var product_total_vat_excluded  = obj.products[key].product.TotalVatExcluded;
                    var product_total               = obj.products[key].product.Total;
                    var product_total_discounted    = obj.products[key].product.TotalDiscounted;
                    var product_currency            = obj.products[key].product.Currency;

                    $(".wc-order-preview-table-wrapper tbody").append(
                        
                        '<tr class="wc-order-preview-table__item bindcommerce-table-row-order-preview">'

                        + '   <td class="wc-order-preview-table__column--product">' + product_description + ' <span style="color:#d80000;"><?php echo __("(Prodotto non presente su WooCommerce)", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?></span>'
                        + '       <div class="wc-order-item-sku">MARM0001</div>'
                        + '   </td>'
                        + '   <td class="wc-order-preview-table__column--quantity">' + product_quantity + '</td>'
                        + '   <td class="wc-order-preview-table__column--tax">'
                        + '       <span class="woocommerce-Price-amount amount">'
                        + '            <bdi>' + product_total_vat_excluded + '<span class="woocommerce-Price-currencySymbol">' + product_currency + '</span></bdi>'
                        + '       </span>'
                        + '   </td>'
                        + '   <td class="wc-order-preview-table__column--total">'
                        + '       <span class="woocommerce-Price-amount amount">'
                        + '            <bdi>' + product_total_discounted + '<span class="woocommerce-Price-currencySymbol">' + product_currency + '</span></bdi>'
                        + '       </span>'
                        + '   </td>'

                        + '</tr>'

                    );

                }


				clearInterval(bindcommerce_missing_products);

			}                    

		}, 100);	


    });

    
    $('body').on('click', '.bc-information-tab', function(e){

        e.preventDefault();
        $(".bc-information-container").toggleClass("bc-hidden");

    });
    
    $(".bc-information-container a").click(function() {

        window.open($(this).attr("href")); 
        return false;

    });

    $("body").on("change", "select.bindcommerce-logs-limit", function() {
        
        var selected_value = $(this).val();

        $("select.bindcommerce-logs-limit").each(function() {
           
            $(this).val(selected_value);

        });

    });

    $('body').on('click', '.bindcommerce-refresh-logs', function(e){

        e.preventDefault();

        var button_clicked = $(this);
        button_clicked.toggleClass("bc-button-updating");
        button_clicked.toggleClass("bc-disabled");

        var selected_value = $("select.bindcommerce-logs-limit").val();

        $.ajax({ 

            method: 'POST',
            url: '<?php echo BindCommerce_Tools::get_plugin_url() . 'includes/ajax/ajax-bindcommerce-get-logs.php'; ?>',
            data: {
                "bindcommerce_ajax_token":      '<?php echo BindCommerce_Setting::get_cron_token(); ?>',
                "bindcommerce_get_logs_limit":  selected_value
            },

            success: function(output) {

                var output_obj = JSON.parse(output);   
                var icon_message = "dashicons-yes-alt";     
                        
                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    $(".bc-logs-container").html(output_obj.data);
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }    

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", false);

            },

            error: function (request, status, error) {
                
                var output = request.responseText;
                var other_messages = "";
                var output_obj = "";
                if (bindcommerce_is_valid_json(output)) {
                    output_obj = JSON.parse(output);
                } else {                    
                    var bracket = '"\u007B'; // apex and curly left bracket
                    other_messages = output.substr(0, output.indexOf(bracket) - 2);
                    output = output.substring(output.indexOf(bracket));
                    output_obj = JSON.parse(JSON.parse(output));
                }

                var icon_message = "dashicons-warning";

                if (output_obj.status == "success") {

                    $(".bc-modal-header").removeClass("bc-error-modal");
                    icon_message = "dashicons-yes-alt";
                    
                } else if (output_obj.status == "error") {     

                    $(".bc-modal-header").addClass("bc-error-modal");
                    icon_message = "dashicons-warning";     

                }

                $("#bc-update-modal").find(".bc-modal-header h2").remove();
                $("#bc-update-modal").find(".bc-modal-header").append( "<h2>" + output_obj.message + "</h2>" );
                $("#bc-update-modal").find(".bc-modal-body .bc-modal-message").each(function() {

                    $(this).remove();

                });

                for(var obj_key in output_obj.logs){

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" + output_obj.logs[obj_key].data + "</p>"
                    );   

                }

                if (other_messages != "") {

                    default_message = "<?php echo __("La richiesta ha restituito i seguenti messaggi:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); ?>";
                    icon_message = "dashicons-warning";

                    $("#bc-update-modal").find(".bc-modal-body").append(
                        "<p class=\"bc-modal-message dashicons-before " + icon_message + "\">" 
                            + default_message 
                            + "<span class=\"bc-other-messages\">" 
                                + other_messages 
                            + "</span>"
                        + "</p>"
                    );

                }

                bc_update_modal.style.display = "block";
                bc_update_modal.setAttribute("refresh", true);

            }  

        }).done(function() {        
            button_clicked.toggleClass("bc-button-updating");
            button_clicked.toggleClass("bc-disabled");
        });

    }); //bindcommerce-refresh-logs-button click


        
}); //document ready

</script>