<?php 
/**
 * Plugin Name:       bindCommerce
 * Plugin URI:        https://www.bindcommerce.com/extensions/woocommerce
 * Description:       Sincronizza il tuo shop con la piattaforma bindCommerce
 * Version:           1.0.1
 * Requires at least: 4.5
 * Requires PHP:      7.2
 * Author:            bindCommerce
 * Author URI:        https://www.bindcommerce.com/
 * License:           GPL v2 or later
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.html
 * Text Domain:       bindcommerce
 * Domain Path:       /languages
 */

if ( ! defined( 'ABSPATH' ) ) { 
    exit; 
}

require_once("autoload.php");

/**
 * 
 * WP Plugin Activation Hook
 * 
 * @since 1.0.0
 * 
 */
function bindcommerce_activation_plugin() {
    
    BindCommerce::activate_plugin();
    flush_rewrite_rules();

} 
register_activation_hook(__FILE__, 'bindcommerce_activation_plugin');


/**
 * 
 * WP Plugin Deactivation Hook
 * 
 * @since 1.0.0
 * 
 */
function bindcommerce_deactivation_plugin() {

    BindCommerce::deactivate_plugin();
    flush_rewrite_rules();    

}
register_deactivation_hook( __FILE__, 'bindcommerce_deactivation_plugin' );


/**
 * 
 * WP Plugin Uninstall Hook
 * 
 * @since 1.0.0
 * 
 */
function bindcommerce_uninstall_plugin() {

    BindCommerce::delete_plugin();
    flush_rewrite_rules();
    
}
register_uninstall_hook( __FILE__, 'bindcommerce_uninstall_plugin' );


?>