<?php

require_once( dirname(__FILE__).'../../../autoload.php' );

if (!defined("ABSPATH")) {
    exit;
}


if (!class_exists('BindCommerce_Ajax_DeleteLogs')) {

    /**
     * 
     * Tha ajax class that allow to delete BindCommerce Debug logs
     *
     * @since 1.0.0
     * 
     */ 
    class BindCommerce_Ajax_DeleteLogs extends BindCommerce {

        public function init()
        {        
            
            // CHECK token 
            if ( !isset($_POST["bindcommerce_ajax_token"]) || !BindCommerce_Cron::is_valid_token($_POST["bindcommerce_ajax_token"]) ) { 
                
                return json_encode( [
                    "status"    => "error",
                    "message"   => __("Token di sicurezza non valido", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                    "logs" => [ 
                        0 => [
                            "data" => __("Il token di sicurezza per effettuare la richiesta non è valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 
                        ]
                    ]
                ]);

            }
            
            // CHECK request 
            if ( !is_numeric($_POST["bindcommerce_delete_logs"]) 
                || is_numeric($_POST["bindcommerce_delete_logs"]) && $_POST["bindcommerce_delete_logs"] != 1 ) {    
            
                BindCommerce_Logger::error( __("La richiesta per la cancellazione dei log non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true);
                
                return json_encode( [
                    "status" => "error",
                    "message" => __("Impossibile completare la richiesta", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                    "logs" => [ 
                        0 => [
                            "data" => __("La richiesta per la cancellazione dei log non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 
                        ]
                    ]
                ]);                                 

            }

            // PROCESS request
            $delete_logs = BindCommerce_Logger::delete_logs();

            if ($delete_logs) {

                return json_encode( [
                    "status" => "success",
                    "message" => __("Impostazioni salvate", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                    "logs" => [ 
                        0 => [
                            "data" => __("Il file di log è stato correttamente eliminato.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 
                        ]
                    ]
                ]);

            } else {

                BindCommerce_Logger::error( __("Impossibile eliminare il file di log.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true);

                return json_encode( [
                    "status" => "error",
                    "message" => __("Impossibile completare la richiesta", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)
                ]);

            }
        
            
        }
        
    }

}

$bindcommerce_ajax = new BindCommerce_Ajax_DeleteLogs();
header("Content-Type: application/json; charset=utf-8");
echo json_encode($bindcommerce_ajax->init());
die();

?>