<?php

require_once( dirname(__FILE__).'../../../autoload.php' );

if (!defined("ABSPATH")) {
    exit;
}


if (!class_exists('BindCommerce_Ajax_Get_Logs')) {

    /**
     * 
     * Tha ajax class that allow to get BindCommerce Debug logs
     *
     * @since 1.0.1
     * 
     */ 
    class BindCommerce_Ajax_Get_Logs extends BindCommerce {

        public function init()
        {        
            
            // CHECK token
            if ( !isset($_POST["bindcommerce_ajax_token"]) || !BindCommerce_Cron::is_valid_token($_POST["bindcommerce_ajax_token"]) ) { 
                
                return json_encode( [
                    "status"    => "error",
                    "message"   => __("Token di sicurezza non valido", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                    "logs" => [ 
                        0 => [
                            "data" => __("Il token di sicurezza per effettuare la richiesta non è valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 
                        ]
                    ]
                ]);

            }
            
            // CHECK request
            if ( !is_numeric($_POST["bindcommerce_get_logs_limit"]) ) {                     
            
                BindCommerce_Logger::error( __("La richiesta per la cattura dei log non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true  );
            
                return json_encode( [
                    "status" => "error",
                    "message" => __("Impossibile completare la richiesta", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                    "logs" => [ 
                        0 => [
                            "data" => __("La richiesta per la cattura dei log non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 
                        ]
                    ]
                ]);

            }    
               
            // PROCESS request                  
            $logs = BindCommerce_Logger::get_logs($_POST["bindcommerce_get_logs_limit"]);
    
            if (empty($logs)) {
                $logs = __("Nessun log catturato", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN); 
            } else {
                $logs = str_replace("\r\n\r\n", "<br />", $logs);
                $logs = str_replace("\r\n", "<br />", $logs);
            }

            return json_encode( [
                "status" => "success",
                "message" => __("Impostazioni salvate", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                "logs" => [ 
                    0 => [
                        "data" => __("Il file di log è stato correttamente caricato.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 
                    ]
                ],
                "data" => $logs
            ]);   
        
            
        }
        
    }

}

$bindcommerce_ajax = new BindCommerce_Ajax_Get_Logs();
header("Content-Type: application/json; charset=utf-8");
echo json_encode($bindcommerce_ajax->init());
die();

?>