<?php

require_once( dirname(__FILE__).'../../../autoload.php' );

if (!defined("ABSPATH")) {
    exit;
}

global $wpdb;

if ( ! class_exists( 'BindCommerce_Ajax_Reset_Settings' ) ) {

    /**
     * 
     * Tha ajax class that allow to reset bindcommerce tables
     *
     * @since 1.0.0
     * 
     */ 
    class BindCommerce_Ajax_Reset_Settings extends BindCommerce {

        public function init()
        {       
            // CHECK token 
            if ( !isset($_POST["bindcommerce_ajax_token"]) || !BindCommerce_Cron::is_valid_token($_POST["bindcommerce_ajax_token"]) ) { 

                BindCommerce_Logger::error( __("Il token di sicurezza per effettuare la richiesta non è valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );                
                
                return json_encode( [
                    "status"    => "error",
                    "message"   => __("Token di sicurezza non valido", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                    "logs" => [ 
                        0 => [
                            "data" => __("Il token di sicurezza per effettuare la richiesta non è valido.") 
                        ]
                    ]
                ]);

            }
            
            // CHECK request
            if ( !is_numeric($_POST["bindcommerce_reset_options"]) 
                || is_numeric($_POST["bindcommerce_reset_options"]) && $_POST["bindcommerce_reset_options"] != 1) {  


                BindCommerce_Logger::error( __("La richiesta per il ripristino delle impostazioni non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true );
        
                return json_encode( [
                    "status" => "error",
                    "message" => __("Impossibile completare la richiesta", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                    "logs" => [ 
                        0 => [
                            "data" => __("La richiesta per il ripristino delle impostazioni non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 
                        ]
                    ]
                ]);                

            } 
                
            // PROCESS request
            BindCommerce_Setup::reset_settings();            
            BindCommerce_Logger::info( __("Impostazioni ripristinate correttamente", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );                    

            return json_encode( [
                "status" => "success",
                "message" => __("Impostazioni salvate", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                "logs" => [ 
                    0 => [
                        "data" => __("Le tabelle e i dati raccolti dal plugin sono stati cancellati correttamente", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 
                    ]
                ]
            ]);
            
        }
        
    }

}

$bindcommerce_ajax = new BindCommerce_Ajax_Reset_Settings();
header("Content-Type: application/json; charset=utf-8");
echo json_encode($bindcommerce_ajax->init());
die();

?>