<?php 

if (!defined("ABSPATH")) {
    exit;
}

if (!class_exists("BindCommerce_HTML_Block")) {

    /**
     * 
     * The BindCommerce_HTML_Block main class
     * 
     * @since 1.0.1
     * 
     */
    class BindCommerce_HTML_Block extends BindCommerce {


        /**
         * 
         * Get the bindcommerce options settings
         * 
         * @since 1.0.1
         * 
         */
        public static function bindcommerce_settings_field($sql) {

            $html = "";
            
            $query_results = BindCommerce_DB::get_results($sql);
            $bindcommerce_strings = new BindCommerce_String();

            foreach ($query_results as $key) { 
                
                $key = (array)$key; // WP

                $option_name        = $key["option_name"];
                $option_value       = $key["option_value"];
                $option_type        = $key["option_type"];
                $option_attributes  = (array)unserialize($key["option_attributes"]);
                $option_class       = isset($option_attributes["class"]) ? $option_attributes["class"] : '';
                $label              = $option_name . "_label";
                $tip                = $option_name . "_tip";
                $tooltip            = !empty($bindcommerce_strings->get_string($option_name . "_tooltip")) ? $bindcommerce_strings->get_string($option_name . "_tooltip") : '';  


                if ($option_type == "input_text" ) { 
                    
                    $html .= "<div class=\"row\">   
                        <div class=\"fc\">                
                            <label class=\"fc\" for=\"" . $option_name . "\">" . $bindcommerce_strings->get_string($label) . "</label> 
                            <p class=\"lbl-tip\">" . $bindcommerce_strings->get_string($tip) . "</p>
                        </div>  
                        <div class=\"sc\">
                            <input 
                                type=\"text\" 
                                class=\"bindcommerce-input " . $option_class . "\" 
                                name=\"" . $option_name . "\" 
                                id=\"" . $option_name . "\" 
                                value=\"" . $option_value . "\"";
                                
                                
                                foreach ($option_attributes as $key => $value) {
                                    if($key != "class") {
                                        $html .= $key . '="' . $value . '"';
                                    }
                                } 
                            
                            $html .= ">
                        </div>
                    </div>    
                    "; 

                }


                if ($option_type == "input_readable" ) {
                    
                    $html .= "<div class=\"row\">   
                        <div class=\"fc\">                
                            <label class=\"fc\" for=\"" . $option_name . "\">" . $bindcommerce_strings->get_string($label) . "</label> 
                            <p class=\"lbl-tip\">" . $bindcommerce_strings->get_string($tip) . "" . $tooltip . "</p>
                        </div>  
                        <div class=\"sc\">
                            <input 
                                type=\"text\"
                                readonly=\"readonly\" 
                                class=\"bindcommerce-input " . $option_class . "\" 
                                name=\"" . $option_name . "\" 
                                id=\"" . $option_name . "\" 
                                value=\"" . $option_value . "\"";
                                
                                
                                foreach ($option_attributes as $key => $value) {
                                    if($key != "class") {
                                        $html .= $key . '="' . $value . '"';
                                    }
                                } 
                            
                            $html .= ">
                        </div>
                    </div>   
                    "; 

                }


                if ($option_type == "textarea" ) {  

                    $html .= "<div class=\"row\">   
                        <div class=\"fc vtop\">                   
                            <label class=\"fc\" for=\"" . $option_name . "\">" . $bindcommerce_strings->get_string($label) . "</label> 
                            <p class=\"lbl-tip\">" . $bindcommerce_strings->get_string($tip) . "</p>
                        </div>              
                        <textarea 
                            class=\"sc bindcommerce-input " . $option_class . "\" 
                            name=\"" . $option_name . "\" 
                            id=\"" . $option_name . "\"";
                            
                            foreach ($option_attributes as $key => $value) {
                                if($key != "class") {
                                    echo $key . '="' . $value . '"';
                                }
                            } 
                            $html .= ">" . $option_value . "
                        </textarea>
                    </div>
                    "; 

                }


                if ($option_type == "select" ) { 

                    $html .= "<div class=\"row\"> 
                        <div class=\"fc\">                    
                            <label for=\"" . $option_name . "\">" . $bindcommerce_strings->get_string($label) . "</label>
                            <p class=\"lbl-tip\">" . $bindcommerce_strings->get_string($tip) . "</p>
                        </div>
                        <div class=\"sc\">
                            <select class=\"sc bindcommerce-input " . $option_class . "\" name=\"" . $option_name . "\" id=\"" . $option_name . "\">";
                            
                            foreach ( (array)(unserialize($option_value)) as $key => $value ) { 

                                $html .= "<option value=\"" . $key . "\""; 
                                    if ($value == true) { $html .= "selected=selected"; } 
                                $html .= ">
                                    " . strtoupper( $key ) . "
                                </option>";

                            }        

                            $html .= " </select>
                        </div>
                    </div> 
                    "; 

                }                

                if ($option_type == "switch" ) { 
                    
                    $html .= "<div class=\"row\"> 
                        <div class=\"fc\">                    
                            <label for=\"" . $option_name . "\">" . $bindcommerce_strings->get_string($label) . "</label>
                            <p class=\"lbl-tip\">" . $bindcommerce_strings->get_string($tip) . "</p>
                        </div>               
                        <div class=\"sc\">
                            <label class=\"bindcommerce-switch " . $option_class . "\">
                                <input type=\"checkbox\" name=\"" . $option_name . "\" class=\"bindcommerce-input bindcommerce-checkbox\""; if ($option_value == 1) { $html .= "checked"; } $html .= ">
                                <span class=\"slider round\"></span>
                            </label>
                        </div>
                    </div>  
                    "; 

                }

                if ($option_type == "select_product_attributes" ) {
                    
                    $html .= "<div class=\"row\"> 
                        <div class=\"fc\">                    
                            <label for=\"" . $option_name . "\">" . $bindcommerce_strings->get_string($label) . "</label>
                            <p class=\"lbl-tip\">" . $bindcommerce_strings->get_string($tip) . "</p>
                        </div>               
                        <div class=\"sc\">
                            <select class=\"sc bindcommerce-input " . $option_class . "\" name=\"" . $option_name  . "\" id=\"" . $option_name . "\">
                                <option disabled selected hidden value>-</option>";
                                
    
                                global $wpdb;
                                $attributes = [];
    
                                $attribute_names = $wpdb->get_col( 
    
                                    "SELECT attribute_name 
                                    FROM " . DB_NAME . "." . BINDCOMMERCE_DB_WP_PREFIX  . BINDCOMMERCE_WC_ATTRIBUTE_TAXONOMIES . "  
                                    WHERE attribute_name != '' 
                                    ORDER BY attribute_name ASC;"                                 
                                    
                                );
    
                                foreach ( $attribute_names as $attribute_name ) {
                                    $attributes[] = $attribute_name;
                                }
                                   
                                if ( !empty($attributes) ) {
                                        
                                    if ($option_value != "") {
    
                                        $attr_exist = false;
                                        foreach ( $attributes as $attribute ) {
    
                                            if ($option_value == $attribute) {
    
                                                $attr_exist = true;
                                                break;
    
                                            }
    
                                        }
    
                                        if (!$attr_exist) {
                                            
                                            BindCommerce_Setting::update_option($option_name, "");
    
                                        }
    
                                    }                                    
    
                                    $html .= "<option value=\"\""; 
                                        if ($option_value == $attribute) { $html .= "selected=selected"; } 
                                    $html .= ">-</option>";
                                        
                                    foreach ( $attributes as $attribute ) {
    
                                        $html .= "<option value=\"" . $attribute . "\""; 
                                            if ($option_value == $attribute) { $html .= "selected=selected"; } 
                                        $html .= ">";
                                            $html .= BindCommerce_DB::get_result("
    
                                                SELECT attribute_label 
                                                FROM " . DB_NAME . "." . BINDCOMMERCE_DB_WP_PREFIX . BINDCOMMERCE_WC_ATTRIBUTE_TAXONOMIES . " " . "
                                                WHERE attribute_name = '". $attribute . "';
                                    
                                            ");
                                        $html .= "</option>";
    
                                    } 
    
                                } else {
    
                                    if ($option_value != "") {
                                        
                                       BindCommerce_Setting::update_option($option_name, "");
    
                                    }
                                    
                                }   
    
                    $html .= "  </select>
                            </div>
                        </div> 
                    ";    
                }
    
    
                if ($option_type == "select_order_statuses" ) { ?>
                    <div class="row"> 
                        <div class="fc">                    
                            <label for="<?php echo $option_name; ?>"><?php echo bindcommerce_string($label); ?></label>
                            <p class="lbl-tip"><?php echo bindcommerce_string($tip); ?></p>
                        </div>               
                        <div class="sc">
                            <select class="sc bindcommerce-input <?php echo $option_class; ?>" name="<?php echo $option_name; ?>" id="<?php echo $option_name; ?>">
                                <option disabled selected hidden value>-</option>
                                <?php
    
                                global $wpdb;
                                $order_statuses = wc_get_order_statuses();
    
                                if (!empty($order_statuses)) {
    
                                    if (!empty($option_value)) {
    
                                        $status_exist = false;
                                        foreach ( $order_statuses as $order_status => $order_label ) {
    
                                            if ($option_value == $order_status) {
    
                                                $status_exist = true;
                                                break;
    
                                            }
    
                                        }
    
                                        if (!$status_exist) {                                        
                                            
                                            BindCommerce_Setting::update_option($option_name, "");
    
                                        }
    
                                    }
    
                                    foreach ( $order_statuses as $order_status => $order_label ) { ?>
    
                                        <option value="<?php echo $order_status ?>" <?php if ($option_value == $order_status) { echo "selected=selected"; } ?>>
                                            <?php echo $order_label; ?>
                                        </option>
    
                                    <?php } 
    
                                } else {
    
                                    if (!empty($option_value)) {
                                        
                                        BindCommerce_Setting::update_option($option_name, "");
    
                                    }
                                    
                                }
    
                                ?>     
    
                            </select>
                        </div>
                    </div>    
                <?php }


            }  
            
            return $html;

        }               

       
        /**
         * 
         * Display HTML Select with a list of WooCommerce Order States
         * 
         * @since 1.0.1
         * 
         */
        public function select_wc_order_states($html_attributes=array(), $option_selected="") {
    
            $order_states = BindCommerce_Order::get_wc_order_states();      

            // Select
            $html = '<select';
            if (!empty($html_attributes)) {

                foreach ($html_attributes as $key => $value) {

                    $html .= ' ' . $key . '="' . $value .'"';

                }

            }
            $html .= '>';

            if (!empty($order_states)) {

                $select_value_exist = false;

                foreach ((array)$order_states as $order_state) {
                    if ($option_selected == $order_state["order_state_id"]) {
                        $select_value_exist = true;
                        break;
                    }
                }

                if (!$select_value_exist) {
                    $html .= '<option value="0" selected="selected">-</option>';
                } else {
                    $html .= '<option value="0">-</option>';
                }

                foreach ((array)$order_states as $order_state) {

                    if ($option_selected == $order_state["order_state_id"]) {
                        $html .= '<option value="' . $order_state["order_state_id"] . '" selected="selected">' . $order_state["order_state_name"] . '</option>';
                    } else {                        
                        $html .= '<option value="' . $order_state["order_state_id"] . '">' . $order_state["order_state_name"] . '</option>';
                    }
                    
                }

            } else {            
                // WooCommerce order states don't exist 
                $html .= '<option value="0" selected="selected">-</option>';
            }
            // End Select
            $html .= '</select>';
            return $html;
    
        }

        
        /**
         * 
         * Display HTML Select with a list of WooCommerce Order State Stock Types
         * 
         * @since 1.0.1
         * 
         */
        public function select_wc_order_state_stock_types($html_attributes=array(), $option_selected="") {
    
            $order_state_types = [
                "0"             => __("-", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                "stock_down"    => __("Scarica Inventario", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
                "stock_up"      => __("Ricarica Inventario", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),
            ];

            // Select
            $html = '<select';
            if (!empty($html_attributes)) {

                foreach ($html_attributes as $key => $value) {

                    $html .= ' ' . $key . '="' . $value .'"';

                }

            }
            $html .= '>';

            foreach ((array)$order_state_types as $key => $value) {

                if ($option_selected === $key) {
                    $html .= '<option value="' . $key . '" selected="selected">' . $value . '</option>';
                } else {                        
                    $html .= '<option value="' . $key . '">' . $value . '</option>';
                }
                
            }

            // End Select
            $html .= '</select>';
            return $html;
    
        }


        /**
         * 
         * Get the bindcommerce mapping order states saved in db
         * 
         * @since 1.0.1
         * 
         */
        public function bindcommerce_order_states_mapping_db() {

            $html = "";
            
            $mappings = BindCommerce_Mapping::get_order_states_mapped();

            if (!empty($mappings)) {

                foreach ($mappings as $mapping) { 
                    
                    $mapping = (array)$mapping;

                    $mapping_order_id                       = $mapping["mapping_order_id"];
                    $mapping_active                         = $mapping["mapping_active"];
                    $id_order_state                         = $mapping["id_order_state"];
                    $mapping_order_bindcommerce_name        = $mapping["mapping_order_bindcommerce_name"];
                    $mapping_order_new_order_stock_type     = $mapping["mapping_order_new_order_stock_type"];
                    $mapping_order_update_order_stock_type  = $mapping["mapping_order_update_order_stock_type"];

                    $mapping_wc_order_states            = $this->select_wc_order_states(
                        array(
                            "id"    => "", 
                            "class" => "bindcommerce-input bindcommerce-order-state-id-field", 
                            "name"  => "bindcommerce_wc_order_state_id"
                        ),
                        $id_order_state
                    );

                    $mapping_order_new_order_stock_types          = $this->select_wc_order_state_stock_types(
                        array(
                            "id"    => "", 
                            "class" => "bindcommerce-input bindcommerce-new-order-stock-field", 
                            "name"  => "bindcommerce_wc_new_order_stock_type"
                        ),
                        $mapping_order_new_order_stock_type
                    );                    

                    $mapping_order_update_order_stock_types          = $this->select_wc_order_state_stock_types(
                        array(
                            "id"    => "", 
                            "class" => "bindcommerce-input bindcommerce-update-order-stock-field", 
                            "name"  => "bindcommerce_wc_update_order_stock_type"
                        ),
                        $mapping_order_update_order_stock_type
                    );

                    if ($mapping_active == 1) {
                        $mapping_active = "checked";
                    } else {
                        $mapping_active = "";
                    }

                    $html .= '
                        <!--Template Input Row-->
                        <tr class="bindcommerce-input-row" data-bindcommerce-delete="0">
                            <input type="hidden" class="bindcommerce-input" name="bindcommerce_mapping_order_id" value="' . $mapping_order_id . '">
                            <input type="hidden" class="bindcommerce-input" name="bindcommerce_order_state_delete" value="0">
                            <td>
                                <label class="bindcommerce-switch">
                                    <input type="checkbox" class="bindcommerce-input bindcommerce-checkbox bindcommerce-mapping-order-state-active-field" name="bindcommerce_mapping_active" ' . $mapping_active . '>
                                    <span class="slider round"></span>
                                </label>
                            </td>
                            <td>
                                <input class="bindcommerce-input bindcommerce-order-state-field" type="text" name="bindcommerce_order_state_name" value="' . $mapping_order_bindcommerce_name . '">
                            </td>
                            <td>
                                ' . $mapping_wc_order_states . '
                            </td>
                            <td>
                                ' . $mapping_order_new_order_stock_types . '
                            </td>
                            <td>
                                ' . $mapping_order_update_order_stock_types . '
                            </td>
                            <td class="bc-action-buttons">
                                <a href="#" class="dashicons-before dashicons-plus bindcommerce-add-field"></a>
                                <a href="#" class="dashicons-before dashicons-admin-page bindcommerce-duplicate-field"></a>
                                <a href="#" class="dashicons-before dashicons-image-rotate bindcommerce-reset-field"></a>
                                <a href="#" class="dashicons-before dashicons-no bindcommerce-remove-field"></a>
                            </td>
                        </tr>
                    ';

                }

            }

            $wc_order_states = $this->select_wc_order_states(
                array(
                    "id"    => "bindcommerce_wc_order_state_id", 
                    "class" => "bindcommerce-input bindcommerce-order-state-id-field", 
                    "name"  => "bindcommerce_wc_order_state_id"
                )
            );

            $mapping_order_new_order_stock_types = $this->select_wc_order_state_stock_types(
                array(
                    "id"    => "",
                    "class" => "bindcommerce-input bindcommerce-new-order-stock-field", 
                    "name"  => "bindcommerce_wc_new_order_stock_type"
                )
            );

            $mapping_order_update_order_stock_types = $this->select_wc_order_state_stock_types(
                array(
                    "id"    => "",
                    "class" => "bindcommerce-input bindcommerce-update-order-stock-field", 
                    "name"  => "bindcommerce_wc_update_order_stock_type"
                )
            );

            // New row line
            $html .= '
                <tr class="bindcommerce-input-row" data-bindcommerce-delete="0">
                    <input type="hidden" class="bindcommerce-input" name="bindcommerce_order_state_delete" value="0">
                    <input type="hidden" class="bindcommerce-input" name="bindcommerce_mapping_order_id" value="">
                    <td>
                        <label class="bindcommerce-switch">
                            <input type="checkbox" class="bindcommerce-input bindcommerce-checkbox bindcommerce-mapping-order-state-active-field" name="bindcommerce_mapping_active">
                            <span class="slider round"></span>
                        </label>
                    </td>
                    <td>
                        <input class="bindcommerce-input bindcommerce-order-state-field" type="text" name="bindcommerce_order_state_name">
                    </td>
                    <td>
                        ' . $wc_order_states . '
                    </td>
                    <td>
                        ' . $mapping_order_new_order_stock_types . '
                    </td>
                    <td>
                        ' . $mapping_order_update_order_stock_types . '
                    </td>
                    <td class="bc-action-buttons">
                        <a href="#" class="dashicons-before dashicons-plus bindcommerce-add-field"></a>
                        <a href="#" class="dashicons-before dashicons-admin-page bindcommerce-duplicate-field"></a>
                        <a href="#" class="dashicons-before dashicons-image-rotate bindcommerce-reset-field"></a>
                        <a href="#" class="dashicons-before dashicons-no bindcommerce-remove-field"></a>
                    </td>
                </tr>
            ';
            
            return $html;

        }

    }

    

}


?>