<?php

if (!defined("ABSPATH")) {
    exit;
}

if (!class_exists('BindCommerce_String')) {

    /**
     * 
     * The main bindCommerce Strings class
     *
     * @since 1.0.1
     * 
     */ 
    class BindCommerce_String extends BindCommerce {


        /**
         * 
         * Get string from key
         *
         * @since 1.0.1
         * 
         */ 
        public function get_string($key) {

            if ($key == "plugin_name") {
                return __("bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_api_key_label") {
                return __("App Name", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_api_key_tip") {
                return __("-", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_api_token_label") {
                return __("Token", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_api_token_tip") {
                return __("Il Token univoco fornito dalla piattaforma bindCommerce per sicronizzare ordini e prodotti con WooCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <span style='display:block;'>" . __("(Es. 050e2Af9709cSz48ced59b35e516d3e0 )", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_cron_token_label") {
                return __("Cronjob Token", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_cron_token_tip") {
                return __("Il Token per validare i cronjob dedicati alla sincronizzazione ordini e prodotti", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_cron_import_products_label") {
                return __("Cron - Importazione Prodotti", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_cron_import_products_tip") {
                return __("Il cronjob dedicato per l'importazione dei prodotti da bindCommerce a WooCommerce.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <a class='bindcommerce-read-mode-btn'>" . __("Mostra altro...", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</a>";
            }
            
            if ($key == "bindcommerce_cron_import_products_tooltip") {
                return "<span class='bindcommerce-read-mode-text bc-hidden'><br /><br />" . __("Parametri consentiti:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>limit</b> " . __("con valore numerico per limitare il numero di prodotti in fase di importazione (Es. limit=20);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>order_by</b> " . __("con valore", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>ASC</b> " . __("o", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>DESC</b> " . __("per l'ordinamento in fase di importazione (Es. order_by=ASC);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_cron_export_products_label") {
                return __("Cron - Esportazione Prodotti", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_cron_export_products_tip") {
                return __("Il cronjob dedicato per l'esportazione di prodotti su bindCommerce.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <a class='bindcommerce-read-mode-btn'>" . __("Mostra altro...", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</a>";
            }
            
            if ($key == "bindcommerce_cron_export_products_tooltip") {
                return "<span class='bindcommerce-read-mode-text bc-hidden'><br /><br />" . __("Parametri consentiti:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br / >- <b style='font-weight:700;'>type</b> " . __("con valore", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) .  " <b style='font-weight:700;'>full</b> " . __("per inviare i dati in modalità full, ", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b>incremental</b> " . __("per inviare i dati in modalità incremental (Es. type=incremental);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br / >- <b style='font-weight:700;'>mode</b> " . __("con valore", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) .  " <b style='font-weight:700;'>full</b> " . __("per inviare tutti i dati,", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b>quantity</b> " . __("per aggiornare solo quantità", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)  . " <b>price</b> " . __("per aggiornare solo i prezzi (Es. mode=full);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>limit</b> " . __("con valore numerico per limitare il numero di prodotti in fase di esportazione (Es. limit=20);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>order_by</b> " . __("con valore", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>ASC</b> " . __("o", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>DESC</b> " . __("per l'ordinamento in fase di esportazione (Es. order_by=ASC);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>start_by</b> " . __("con valore numerico per impostare il primo ID prodotto da processare (Es. start_by=1);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>end_by</b> " . __("con valore numerico per impostare l'ultimo ID prodotto da processare (Es. end_by=20);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_cron_import_orders_label") {
                return __("Cron - Importazione Ordini", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_cron_import_orders_tip") {
                return __("Il cronjob dedicato per l'importazione degli ordini da bindCommerce a WooCommerce.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <a class='bindcommerce-read-mode-btn'>" . __("Mostra altro...", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</a>";
            }

            if ($key == "bindcommerce_cron_import_orders_tooltip") {
                return "<span class='bindcommerce-read-mode-text bc-hidden'><br /><br />" . __("Parametri consentiti:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>limit</b> " . __("con valore numerico per limitare il numero di ordini in fase di importazione (Es. limit=20);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>order_by</b> " . __("con valore", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>ASC</b> " . __("o", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>DESC</b> " . __("per l'ordinamento in fase di importazione (Es. order_by=ASC);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_cron_update_wc_orders_label") {
                return __("Cron - Aggiornamento Ordini", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_cron_update_wc_orders_tip") {
                return __("Il cronjob dedicato per l'aggiornamento degli ordini già importati su WooCommerce.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <a class='bindcommerce-read-mode-btn'>" . __("Mostra altro...", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</a>";
            }

            if ($key == "bindcommerce_cron_update_wc_orders_tooltip") {
                return "<span class='bindcommerce-read-mode-text bc-hidden'><br /><br />" . __("Parametri consentiti:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>limit</b> " . __("con valore numerico per limitare il numero di ordini in fase di importazione (Es. limit=20);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>order_by</b> " . __("con valore", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>ASC</b> " . __("o", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>DESC</b> " . __("per l'ordinamento in fase di importazione (Es. order_by=ASC);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_cron_export_orders_label") {
                return __("Cron - Esportazione Ordini", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_cron_export_orders_tip") {
                return __("Il cronjob dedicato per l'esportazione degli ordini su bindCommerce.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <a class='bindcommerce-read-mode-btn'>" . __("Mostra altro...", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</a>";
            }

            if ($key == "bindcommerce_cron_export_orders_tooltip") {
                return "<span class='bindcommerce-read-mode-text bc-hidden'><br /><br />" . __("Parametri consentiti:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>limit</b> " . __("con valore numerico per limitare il numero di ordini in fase di esportazione (Es. limit=20);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>order_by</b> " . __("con valore", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>ASC</b> " . __("o", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>DESC</b> " . __("per l'ordinamento in fase di esportazione (Es. order_by=ASC);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_cron_export_order_states_label") {
                return __("Cron - Aggiornamento Stato d'Ordine", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_cron_export_order_states_tip") {
                return __("Il cronjob dedicato per l'aggiornamento degli stati d'ordini presenti su bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_cron_export_order_states_tooltip") {
                return "<span class='bindcommerce-read-mode-text bc-hidden'><br /><br />" . __("Parametri consentiti:", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>limit</b> " . __("con valore numerico per limitare il numero di ordini in fase di esportazione (Es. limit=20);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "<br />- <b style='font-weight:700;'>order_by</b> " . __("con valore", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>ASC</b> " . __("o", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . " <b style='font-weight:700;'>DESC</b> " . __("per l'ordinamento in fase di esportazione (Es. order_by=ASC);", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_api_connector_import_orders_label") {
                return __("Connettore per Import Ordini", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_api_connector_import_orders_tip") {
                return __("Il connettore dedicato per l'importazione degli ordini da bindCommerce a WooCommerce,  rilasciato dalla piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)  . "<span style='display:block;'>" . __("(Es. https://i0000XX.bindcommerce.cloud/integrator-tool/api/export_orders.php?connector=44 )", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_api_connector_export_orders_label") {
                return __("Connettore per Export Ordini", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_api_connector_export_orders_tip") {
                return __("Il connettore dedicato per l'esportazione degli ordini da WooCommerce a bindCommerce, rilasciato dalla piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)  . "<span style='display:block;'>" . __("(Es. https://i0000XX.bindcommerce.cloud/integrator-tool/api/import_orders.php?connector=44 )", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_api_connector_import_products_label") {
                return __("Connettore per Import Prodotti", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_api_connector_import_products_tip") {
                return __("Il connettore dedicato per l'importazione dei prodotti da bindCommerce a WooCommerce, rilasciato dalla piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)  . "<span style='display:block;'>" . __("(Es. https://i0000XX.bindcommerce.cloud/integrator-tool/api/import_products.php?connector=43 )", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_api_connector_export_products_label") {
                return __("Connettore per Export Prodotti", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_api_connector_export_products_tip") {
                return __("Il connettore dedicato per l'esportazione dei prodotti da WooCommerce a bindCommerce, rilasciato dalla piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)  . "<span style='display:block;'>" . __("(Es. https://i0000XX.bindcommerce.cloud/integrator-tool/api/export_products.php?connector=43 )", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) . "</span>";
            }

            if ($key == "bindcommerce_products_sync_edit_product_status_label") {
                return  __("Aggiornamento Prodotti Automatico", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_sync_edit_product_status_tip") {
                return  __("L'opzione permette di aggiornare i prodotti su bindCommerce ad ogni salvataggio effettuato nella scheda prodotto", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_gtin_fields_label") {
                return  __("Codici GTIN", "bindcommerce");
            }
    
            if ($key == "bindcommerce_gtin_fields_tip") {
                return  __("L'opzione permette di attivare o disattivare i campi GTIN nella scheda prodotto", "bindcommerce");
            }
    
            if ($key == "bindcommerce_gtin_front_end_fields_label") {
                return  __("Mostra codici GTIN", "bindcommerce");
            }
    
            if ($key == "bindcommerce_gtin_front_end_fields_tip") {
                return  __("L'opzione permette di mostrare o nascondere i campi GTIN nella scheda prodotto visibile alla clientela", "bindcommerce");
            }

            if ($key == "bindcommerce_products_export_drafts_label") {
                return  __("Esporta Prodotti Bozza", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_export_drafts_tip") {
                return  __("L'opzione permette di esportare i prodotti presenti su WooCommerce con stato bozza sulla piattaforma bindCommerce, quando l'opzione non è attiva eliminerà eventuali prodotti in bozza presenti su bindCommerce precedentemente esportati", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }      

            if ($key == "bindcommerce_products_import_mode_label") {
                return  __("Codice Prodotto", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_import_mode_tip") {
                return  __("Il codice che il plugin assegnerà durante l'esportazione di ogni prodotto presente su WooCommerce allo SKU sulla piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_import_prefix_status_label") {
                return  __("Prefisso Prodotti", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_import_prefix_status_tip") {
                return  __("L'opzione permette di attivare o disattivare un prefisso dedicato per i prodotti sincronizzati con la piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_import_prefix_label") {
                return  __("Etichetta Prefisso Prodotti", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_import_prefix_tip") {
                return  __("Il prefisso che il plugin aggiungerà ad ogni prodotto sincronizzato con la piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }
            
            if ($key == "bindcommerce_products_tax_status_amount_label") {
                return  __("Aliquota IVA", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_tax_status_amount_tip") {
                return  __("L'opzione permette di attivare o disattivare il ricarico dell'aliquota IVA per i prodotti da esportare su bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_tax_value_amount_label") {
                return  __("Ricarico IVA", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_tax_value_amount_tip") {
                return  __("Il ricarico IVA espresso in percentuale che il plugin aggiungerà ad ogni prodotto esportato sulla piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_supplement_status_amount_label") {
                return  __("Supplemento bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_supplement_status_amount_tip") {
                return  __("L'opzione permette di attivare o disattivare un supplemento dedicato per i prodotti da esportare su bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_supplement_value_amount_label") {
                return  __("Ricarico bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_products_supplement_value_amount_tip") {
                return  __("Il ricarico dedicato alla piattaforma bindCommerce espresso in percentuale o importo fisso che il plugin aggiungerà ad ogni prodotto esportato", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_orders_force_order_import_label") {
                return  __("Forza Importazioni Ordini", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_orders_force_order_import_tip") {
                return  __("L'opzione permette di forzare l'importazione degli ordini dalla piattaforma bindCommerce, quando un oggetto non è presente su WooCommerce con un prodotto fittizio", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_mapping_product_manufacturer_label") {
                return  __("Mapping Brand", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }
    
            if ($key == "bindcommerce_mapping_product_manufacturer_tip") {
                return  __("L'attributo che identifica la Marca/Produttore durante la sincronizzazione dei prodotti con la piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }
    
            if ($key == "bindcommerce_mapping_product_supplier_label") {
                return  __("Mapping Fornitore", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }
    
            if ($key == "bindcommerce_mapping_product_supplier_tip") {
                return  __("L'attributo che identifica il Fornitore durante la sincronizzazione dei prodotti con la piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_mapping_order_status_shipping_label") {
                return  __("Mapping Stato 'Spedito'", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_mapping_order_status_shipping_tip") {
                return  __("Lo stato d'ordine che identifica lo stato 'Spedito' durante la sincronizzazione degli ordini con la piattaforma bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_debug_mode_label") {
                return  __("Modalità Debug", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_debug_mode_tip") {
                return  __("L'opzione permette di attivare o disattivare la modalità debug dedicata per catturare errori e avvisi relativi al plugin bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_debug_mode_view_label") {
                return  __("Visualizza Log", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_debug_mode_view_tip") {
                return  __("L'opzione permette di mostrare i log catturati dalla modalità debug dedicata direttamente dal pannello del plugin bindCommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_debug_notify_email_label") {
                return  __("Notifica Log via Email", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_debug_notify_email_tip") {
                return  __("L'opzione permette di ricevere i log catturati dalla modalità debug dedicata via email", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_debug_notify_email_list_label") {
                return  __("Lista Email per Invio Log", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_debug_notify_email_list_tip") {
                return  __("Gli indirizzi email al quale inviare le notifiche catturate dalla modalità debug dedicata relative al plugin bindcommerce", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }            

            if ($key == "bindcommerce_delete_all_data_after_uninstall_label") {
                return  __("Elimina Dati", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }

            if ($key == "bindcommerce_delete_all_data_after_uninstall_tip") {
                return  __("L'opzione permette di cancellare tutti i dati generati e salvati dall'estensione di bindCommerce dopo la disinstallazione del plugin.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN);
            }
            

        }

    } 

}